Index: src/incremen.c
--- src/incremen.c.orig	2004-09-06 13:30:42 +0200
+++ src/incremen.c	2004-12-20 19:55:06 +0100
@@ -133,6 +133,8 @@
   if (! dirp)
     {
       savedir_error (dir_name);
+      errno = 1;
+      return;
     }
   errno = 0;
 
Index: src/utf8.c
--- src/utf8.c.orig	2004-10-25 16:14:53 +0200
+++ src/utf8.c	2004-12-20 19:54:25 +0100
@@ -22,6 +22,9 @@
 #include "common.h"
 #ifdef HAVE_ICONV_H
 # include <iconv.h>
+#else
+# define iconv_t void *
+# define ICONV_CONST const
 #endif
 
 #ifndef ICONV_CONST
Index: src/xheader.c
--- src/xheader.c.orig	2004-09-06 13:31:14 +0200
+++ src/xheader.c	2004-12-20 19:54:25 +0100
@@ -23,6 +23,7 @@
 #include <quotearg.h>
 #include <stpcpy.h>
 #include <xstrtol.h>
+#include <stpcpy.h>
 
 #include "common.h"
 
Index: rmt/rmt.c
--- rmt/rmt.c.orig	2004-09-06 15:49:41 +0200
+++ rmt/rmt.c	2004-12-20 20:01:28 +0100
@@ -38,6 +38,7 @@
 
 #include <getopt.h>
 #include <sys/socket.h>
+#include <locale.h>
 
 #ifndef EXIT_FAILURE
 # define EXIT_FAILURE 1
Index: src/tar.c
--- src/tar.c.orig	2004-12-21 15:11:26 +0100
+++ src/tar.c	2005-01-31 21:34:57 +0100
@@ -20,6 +20,7 @@
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
 
 #include <system.h>
+#include <locale.h>
 
 #include <fnmatch.h>
 #include <argp.h>
@@ -617,9 +618,9 @@
   
   switch (key)
     {
-      case 1:
+      case ARGP_KEY_ARG:
 	/* File name or non-parsed option, because of ARGP_IN_ORDER */
-	name_add (optarg);
+	name_add (arg);
 	args->input_files++;
 	break;
 
Index: src/compare.c
--- src/compare.c.orig	2004-09-06 13:30:29 +0200
+++ src/compare.c	2005-01-31 21:34:57 +0100
@@ -327,7 +327,7 @@
 	size_t len = strlen (current_stat_info.link_name);
 	char *linkbuf = alloca (len + 1);
 
-	status = readlink (current_stat_info.file_name, linkbuf, len + 1);
+	status = readlink (current_stat_info.file_name, linkbuf, len);
 
 	if (status < 0)
 	  {
Index: src/create.c
--- src/create.c.orig	2004-10-04 11:21:31 +0200
+++ src/create.c	2005-01-31 21:34:57 +0100
@@ -1482,7 +1482,7 @@
 	  if (linklen != st->stat.st_size || linklen + 1 == 0)
 	    xalloc_die ();
 	  buffer = (char *) alloca (linklen + 1);
-	  size = readlink (p, buffer, linklen + 1);
+	  size = readlink (p, buffer, linklen);
 	  if (size < 0)
 	    {
 	      readlink_diag (p);
